// This file is automatically generated, please don't edit manually.
package network

import (
	"fmt"
)

// Get key type
func getSettingVpnKeyType(key string) (t ktype) {
	switch key {
	default:
		t = ktypeUnknown
	case NM_SETTING_VPN_SERVICE_TYPE:
		t = ktypeString
	case NM_SETTING_VPN_USER_NAME:
		t = ktypeString
	case NM_SETTING_VPN_DATA:
		t = ktypeDictStringString
	case NM_SETTING_VPN_SECRETS:
		t = ktypeDictStringString
	}
	return
}

// Check is key in current setting section
func isKeyInSettingVpn(key string) bool {
	switch key {
	case NM_SETTING_VPN_SERVICE_TYPE:
		return true
	case NM_SETTING_VPN_USER_NAME:
		return true
	case NM_SETTING_VPN_DATA:
		return true
	case NM_SETTING_VPN_SECRETS:
		return true
	}
	return false
}

// Get key's default value
func getSettingVpnDefaultValue(key string) (value interface{}) {
	switch key {
	default:
		logger.Error("invalid key:", key)
	case NM_SETTING_VPN_SERVICE_TYPE:
		value = ""
	case NM_SETTING_VPN_USER_NAME:
		value = ""
	case NM_SETTING_VPN_DATA:
		value = make(map[string]string)
	case NM_SETTING_VPN_SECRETS:
		value = make(map[string]string)
	}
	return
}

// Get JSON value generally
func generalGetSettingVpnKeyJSON(data connectionData, key string) (value string) {
	switch key {
	default:
		logger.Error("generalGetSettingVpnKeyJSON: invalide key", key)
	case NM_SETTING_VPN_SERVICE_TYPE:
		value = getSettingVpnServiceTypeJSON(data)
	case NM_SETTING_VPN_USER_NAME:
		value = getSettingVpnUserNameJSON(data)
	case NM_SETTING_VPN_DATA:
		value = getSettingVpnDataJSON(data)
	case NM_SETTING_VPN_SECRETS:
		value = getSettingVpnSecretsJSON(data)
	}
	return
}

// Set JSON value generally
func generalSetSettingVpnKeyJSON(data connectionData, key, valueJSON string) (err error) {
	switch key {
	default:
		logger.Error("generalSetSettingVpnKeyJSON: invalide key", key)
	case NM_SETTING_VPN_SERVICE_TYPE:
		err = setSettingVpnServiceTypeJSON(data, valueJSON)
	case NM_SETTING_VPN_USER_NAME:
		err = setSettingVpnUserNameJSON(data, valueJSON)
	case NM_SETTING_VPN_DATA:
		err = setSettingVpnDataJSON(data, valueJSON)
	case NM_SETTING_VPN_SECRETS:
		err = setSettingVpnSecretsJSON(data, valueJSON)
	}
	return
}

// Check if key exists
func isSettingVpnServiceTypeExists(data connectionData) bool {
	return isSettingKeyExists(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE)
}
func isSettingVpnUserNameExists(data connectionData) bool {
	return isSettingKeyExists(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME)
}
func isSettingVpnDataExists(data connectionData) bool {
	return isSettingKeyExists(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA)
}
func isSettingVpnSecretsExists(data connectionData) bool {
	return isSettingKeyExists(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS)
}

// Ensure section and key exists and not empty
func ensureSectionSettingVpnExists(data connectionData, errs sectionErrors, relatedKey string) {
	if !isSettingSectionExists(data, NM_SETTING_VPN_SETTING_NAME) {
		rememberError(errs, relatedKey, NM_SETTING_VPN_SETTING_NAME, fmt.Sprintf(NM_KEY_ERROR_MISSING_SECTION, NM_SETTING_VPN_SETTING_NAME))
	}
	sectionData, _ := data[NM_SETTING_VPN_SETTING_NAME]
	if len(sectionData) == 0 {
		rememberError(errs, relatedKey, NM_SETTING_VPN_SETTING_NAME, fmt.Sprintf(NM_KEY_ERROR_EMPTY_SECTION, NM_SETTING_VPN_SETTING_NAME))
	}
}
func ensureSettingVpnServiceTypeNoEmpty(data connectionData, errs sectionErrors) {
	if !isSettingVpnServiceTypeExists(data) {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE, NM_KEY_ERROR_MISSING_VALUE)
	}
	value := getSettingVpnServiceType(data)
	if len(value) == 0 {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE, NM_KEY_ERROR_EMPTY_VALUE)
	}
}
func ensureSettingVpnUserNameNoEmpty(data connectionData, errs sectionErrors) {
	if !isSettingVpnUserNameExists(data) {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME, NM_KEY_ERROR_MISSING_VALUE)
	}
	value := getSettingVpnUserName(data)
	if len(value) == 0 {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME, NM_KEY_ERROR_EMPTY_VALUE)
	}
}
func ensureSettingVpnDataNoEmpty(data connectionData, errs sectionErrors) {
	if !isSettingVpnDataExists(data) {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA, NM_KEY_ERROR_MISSING_VALUE)
	}
	value := getSettingVpnData(data)
	if len(value) == 0 {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA, NM_KEY_ERROR_EMPTY_VALUE)
	}
}
func ensureSettingVpnSecretsNoEmpty(data connectionData, errs sectionErrors) {
	if !isSettingVpnSecretsExists(data) {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS, NM_KEY_ERROR_MISSING_VALUE)
	}
	value := getSettingVpnSecrets(data)
	if len(value) == 0 {
		rememberError(errs, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS, NM_KEY_ERROR_EMPTY_VALUE)
	}
}

// Getter
func getSettingVpnServiceType(data connectionData) (value string) {
	ivalue := getSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE)
	value = interfaceToString(ivalue)
	return
}
func getSettingVpnUserName(data connectionData) (value string) {
	ivalue := getSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME)
	value = interfaceToString(ivalue)
	return
}
func getSettingVpnData(data connectionData) (value map[string]string) {
	ivalue := getSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA)
	value = interfaceToDictStringString(ivalue)
	return
}
func getSettingVpnSecrets(data connectionData) (value map[string]string) {
	ivalue := getSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS)
	value = interfaceToDictStringString(ivalue)
	return
}

// Setter
func setSettingVpnServiceType(data connectionData, value string) {
	setSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE, value)
}
func setSettingVpnUserName(data connectionData, value string) {
	setSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME, value)
}
func setSettingVpnData(data connectionData, value map[string]string) {
	setSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA, value)
}
func setSettingVpnSecrets(data connectionData, value map[string]string) {
	setSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS, value)
}

// JSON Getter
func getSettingVpnServiceTypeJSON(data connectionData) (valueJSON string) {
	valueJSON = getSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE, getSettingVpnKeyType(NM_SETTING_VPN_SERVICE_TYPE))
	return
}
func getSettingVpnUserNameJSON(data connectionData) (valueJSON string) {
	valueJSON = getSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME, getSettingVpnKeyType(NM_SETTING_VPN_USER_NAME))
	return
}
func getSettingVpnDataJSON(data connectionData) (valueJSON string) {
	valueJSON = getSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA, getSettingVpnKeyType(NM_SETTING_VPN_DATA))
	return
}
func getSettingVpnSecretsJSON(data connectionData) (valueJSON string) {
	valueJSON = getSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS, getSettingVpnKeyType(NM_SETTING_VPN_SECRETS))
	return
}

// JSON Setter
func setSettingVpnServiceTypeJSON(data connectionData, valueJSON string) (err error) {
	return setSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE, valueJSON, getSettingVpnKeyType(NM_SETTING_VPN_SERVICE_TYPE))
}
func setSettingVpnUserNameJSON(data connectionData, valueJSON string) (err error) {
	return setSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME, valueJSON, getSettingVpnKeyType(NM_SETTING_VPN_USER_NAME))
}
func setSettingVpnDataJSON(data connectionData, valueJSON string) (err error) {
	return setSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA, valueJSON, getSettingVpnKeyType(NM_SETTING_VPN_DATA))
}
func setSettingVpnSecretsJSON(data connectionData, valueJSON string) (err error) {
	return setSettingKeyJSON(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS, valueJSON, getSettingVpnKeyType(NM_SETTING_VPN_SECRETS))
}

// Logic JSON Setter

// Remover
func removeSettingVpnServiceType(data connectionData) {
	removeSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SERVICE_TYPE)
}
func removeSettingVpnUserName(data connectionData) {
	removeSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_USER_NAME)
}
func removeSettingVpnData(data connectionData) {
	removeSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_DATA)
}
func removeSettingVpnSecrets(data connectionData) {
	removeSettingKey(data, NM_SETTING_VPN_SETTING_NAME, NM_SETTING_VPN_SECRETS)
}
